<%args>
    $type    => undef
    $id      => undef
    $filled  => undef
    $profile => undef
</%args>

<& /service/open_form.mhtml, action => 'change_csr_profile.html' &>

<& /lib/html/hidden.mhtml, 'name' => 'type',   'value' => $type &>
<& /lib/html/hidden.mhtml, 'name' => 'id',     'value' => $id &>
<& /lib/html/hidden.mhtml, 'name' => 'filled', 'value' => '1' &>

<h1><% i18nGettext ('I18N_OPENXPKI_CLIENT_HTML_MASON_ACTIVITY_CHANGE_CSR_PROFILE_TITLE') %></h1>
<p>
  <% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_ACTIVITY_CHANGE_CSR_PROFILE_DESCRIPTION') %>
</p>
<p>
<& /lib/html/select.mhtml,
   'name'    => "profile",
   'default' => [ $profile ],
   'values'  => [ @profiles ] &>
</p>
<& /service/send_form.mhtml &>
<& /service/close_form.mhtml &>

<& /service/create_csr/print_errors.mhtml, 'errors' => \@errors &>

<%init>
    my @errors = ();
    my @profiles  = ();

    if (not $filled)
    {
        ## load the role from the workflow
        my $msg = $context->{client}->send_receive_command_msg
                  (
                      "get_workflow_info",
                      {
                          "WORKFLOW" => $type,
                          "ID"       => $id
                      }
                  );
        $profile = $msg->{PARAMS}->{WORKFLOW}->{CONTEXT}->{cert_profile};

        ## read all profiles from the server
        $msg = $context->{client}->send_receive_command_msg("get_cert_profiles");
        @profiles = keys %{$msg->{PARAMS}};

        ## if there is only one option then there is no choice
        if (scalar @profiles == 1)
        {
            $profile = $profiles[0];
        }
    }

    if ($filled or scalar @profiles == 1)
    {
        ## let it scan by the server
        my $msg = $context->{client}->send_receive_command_msg (
                      "execute_workflow_activity",
                      {WORKFLOW => $type,
                       ID       => $id,
                       ACTIVITY => "I18N_OPENXPKI_WF_ACTION_CHANGE_CSR_PROFILE",
                       PARAMS   => {"cert_profile" => $profile}});
        if (exists $msg->{SERVICE_MSG} and
            $msg->{SERVICE_MSG} eq "ERROR")
        {
            @errors = $m->comp ('/lib/get_deep_error.mhtml', 'msg' => $msg);
        }
        else
        {
            return $m->comp ('/service/workflow/show_instance.html',
                             'msg'  => $msg,
                             'type' => $type,
                             'id'   => $id);
        }
    }

    ## ok, we have to ask the user
</%init>
